package net.rmi.armi;

import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

public class RmiHelloClient {
    private String rmiUrl = null;
    private RemoteHelloInterface rh = null;

    public RmiHelloClient(String location) {
        rmiUrl = location;
        try {
            rh = lookupDelgate();
        } catch (NotBoundException e) {
            e.printStackTrace();
        } catch (java.net.MalformedURLException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
    public RemoteHelloInterface getRemoteHelloInterface() {
        return rh;
    }

    private RemoteHelloInterface lookupDelgate()
            throws NotBoundException,
            java.net.MalformedURLException,
            RemoteException {
        RemoteHelloInterface rh = (RemoteHelloInterface)
                Naming.lookup(rmiUrl);
        return rh;
    }

    public static void main(String args[]) {
        try {
            RmiHelloClient rhc =
                    new RmiHelloClient(
                            "rmi://localhost/RemoteHello");
            RemoteHelloInterface remoteHelloInterface = rhc.getRemoteHelloInterface();
            String ans = remoteHelloInterface.getMsg();
            System.out.println(ans);
        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }
    public String getMsg() throws RemoteException {
        return rh.getMsg();
    }

    public void testGetMsg()
            throws
            RemoteException {
        System.out.println(rh.getMsg());
    }
}
